--[[
Top Parses on Boss Tooltip
Configuration Page
]]--
local _, addon = ...;

-- Create a frame
function createTPBTFrame() 
	--addon.isShowing = true

	TPBT_ParentFrame = CreateFrame("Frame", "TPBT_ParentFrame", UIParent)
	TPBT_ParentFrame:SetResizable(true)
	TPBT_ParentFrame:SetMovable(true)
	TPBT_ParentFrame:EnableMouse(true)
	TPBT_ParentFrame:SetWidth(420)
	TPBT_ParentFrame:SetHeight(120)
	TPBT_ParentFrame:SetMinResize(300, 90) -- Real, change back to this
	--TPBT_ParentFrame:SetMinResize(20, 90) -- For testing wraps
	TPBT_ParentFrame:SetMaxResize(500, 200)
	TPBT_ParentFrame:RegisterForDrag("LeftButton")
	TPBT_ParentFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	TPBT_ParentFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	
	
	-- Texture
	TPBT_ParentFrameTexture = TPBT_ParentFrame:CreateTexture(nil, "Background")
	TPBT_ParentFrameTexture:ClearAllPoints()
	--TPBT_ParentFrameTexture:SetColorTexture(35/255, 35/255, 35/255, 0.0)
	--TPBT_ParentFrameTexture:SetAllPoints(TPBT_ParentFrame)
	------
	
	-- Resize Button
	local resizeButton = CreateFrame("Button", nil, TPBT_ParentFrame)
	resizeButton:SetSize(16, 16)
	resizeButton:SetPoint("BOTTOMRIGHT")
	resizeButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
	resizeButton:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
	resizeButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
 
	resizeButton:SetScript("OnMouseDown", function(self, button)
    TPBT_ParentFrame:StartSizing("BOTTOMRIGHT")
    TPBT_ParentFrame:SetUserPlaced(true)
end)
 
	resizeButton:SetScript("OnMouseUp", function(self, button)
    TPBT_ParentFrame:StopMovingOrSizing()
end)
	--
	
	
	



	-- Header Panel
	TPBT_HeaderPanel = CreateFrame("Frame", "TPBT_HeaderFrame", TPBT_ParentFrame)	
	TPBT_HeaderPanel:SetFrameStrata("Background")
	--TPBT_HeaderPanel:SetAllPoints(TPBT_ParentFrame)
	

	
	-- Header Texture
	TPBT_HeaderPanelTexture = TPBT_HeaderPanel:CreateTexture(nil, "Background")

	TPBT_HeaderPanelTexture:ClearAllPoints()
	TPBT_HeaderPanelTexture:SetColorTexture(65/255, 60/255, 55/255, 0.75)
	TPBT_HeaderPanelTexture:SetAllPoints(TPBT_HeaderPanel)
	
	-- Header Text
	headerTPBT = TPBT_HeaderPanel:CreateFontString("TPBT_HeaderText", nil, nil)
	headerTPBT:SetPoint("TOPLEFT", 5, -4)
	headerTPBT:SetPoint("TOPRIGHT", 5, -4)
	headerTPBT:SetFont("Fonts\\SKURRI.TTF", 16, "OUTLINE")
	headerTPBT:SetTextColor(239/255, 191/255, 90/255)
	headerTPBT:SetJustifyH("LEFT")
	headerTPBT:SetJustifyV("CENTER")
	headerTPBT:SetText("Top Parses on Boss Tooltip")
	headerTPBT:SetWordWrap(true)
	
	TPBT_HeaderPanel:SetPoint("TOPLEFT", TPBT_ParentFrame, "TOPLEFT", 0, 0)
	TPBT_HeaderPanel:SetPoint("TOPRIGHT", TPBT_ParentFrame, "TOPRIGHT", 0, 0)
	TPBT_HeaderPanel:SetHeight(22)
	TPBT_HeaderPanel:SetWidth(450)
	TPBT_HeaderPanel:Show()
	
	
	-----------------
	-- TIPS PANEL ---
	-----------------
	TPBT_ParsePanel = CreateFrame("Frame", "TPBT_TipFrame", TPBT_ParentFrame)
	
	TPBT_ParsePanel:SetFrameStrata("Background")
	TPBT_ParsePanel:SetWidth(450)
	--TPBT_ParsePanel:SetHeight(98)
	TPBT_ParsePanel:SetPoint("TOPLEFT", TPBT_HeaderPanel, "BOTTOMLEFT", 0, 0)
	TPBT_ParsePanel:SetPoint("TOPRIGHT", TPBT_HeaderPanel, "BOTTOMRIGHT", 0, 0)
	TPBT_ParsePanel:SetPoint("BOTTOMLEFT", TPBT_ParentFrame, "BOTTOMLEFT", 0, 0)
	TPBT_ParsePanel:SetPoint("BOTTOMRIGHT", TPBT_ParentFrame, "BOTTOMRIGHT", 0, 0)
	
	-- Tip Texture
	TPBT_ParsePanelTexture = TPBT_ParsePanel:CreateTexture(nil, "Background")
	--TPBT_ParsePanelTexture:SetWidth(128)
	--TPBT_ParsePanelTexture:SetHeight(64)
	TPBT_ParsePanelTexture:ClearAllPoints()
	TPBT_ParsePanelTexture:SetColorTexture(55/255, 55/255, 55/255, 0.55)
	TPBT_ParsePanelTexture:SetAllPoints(TPBT_ParsePanel)
	
	
	TPBT_ParsePanel:Show()
	
	

	TPBT_MobName = TPBT_ParsePanel:CreateFontString("TPBT_MobName", nil, nil)
	TPBT_MobName:SetPoint("TOPLEFT", 5, -5)
	TPBT_MobName:SetPoint("TOPRIGHT", 5, -5)
	TPBT_MobName:SetWordWrap(true)
	TPBT_MobName:SetFont("Fonts\\ARIALN.ttf", 16, "OUTLINE")
	TPBT_MobName:SetJustifyH("LEFT")
	TPBT_MobName:SetJustifyV("TOP")
	TPBT_MobName:SetText(" ")

	-- Frame Tip Text
	TPBT_ParseText = TPBT_ParsePanel:CreateFontString("TPBT_ParseText", nil, GameFontNormal)
	TPBT_ParseText:SetPoint("TOPLEFT", TPBT_MobName, "BOTTOMLEFT", 0, -3)
	TPBT_ParseText:SetPoint("TOPRIGHT", TPBT_MobName, "BOTTOMRIGHT", -3, -3)
	TPBT_ParseText:SetPoint("BOTTOMLEFT", TPBT_ParentFrame, "BOTTOMLEFT", 0, 0)
	TPBT_ParseText:SetPoint("BOTTOMRIGHT", TPBT_ParentFrame, "BOTTOMRIGHT", 0, 0)
	--TPBT_ParseText:SetFont("Fonts\\ARIALN.ttf", 14, nil)
	TPBT_ParseText:SetFontObject(GameFontWhite);
	local p,_,_ = TPBT_ParseText:GetFont();
	--print("Creating Frame" .. TPBTConfig.FontSize)
	TPBT_ParseText:SetFont(p, TPBTConfig.FontSize, nil)
	TPBT_ParseText:SetWidth(445)
	TPBT_ParseText:SetJustifyH("LEFT")
	TPBT_ParseText:SetJustifyV("TOP")
	TPBT_ParseText:SetText(" ")
	-----------------------
	
	
	-- Show Frame
	TPBT_ParentFrame:SetPoint("CENTER", UIParent)
	TPBT_ParentFrame:Show()	
	
	
	TPBT_ParentFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	TPBT_ParentFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
	TPBT_ParentFrame:RegisterEvent("ENCOUNTER_START")
	TPBT_ParentFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
	TPBT_ParentFrame:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
	TPBT_ParentFrame:SetScript("OnEvent", function(self, event, ...)

		if event == "PLAYER_ENTERING_WORLD" then
			C_Timer.After(2, function() addon:setEnabled() end)
			--addon:setEnabled()
		elseif event == "PLAYER_TARGET_CHANGED" then
			--print("Player target changed" .. TPBTConfig.TargetTrigger .. TPBT_onBoss)
			if TPBTConfig.TargetTrigger == "Show targeted mob" and not TPBT_onBoss then addon:getTarget("target") end	
			
		elseif event == "INSTANCE_ENCOUNTER_ENGAGE_UNIT" and UnitExists("boss1") then
			--TPBT_onBoss = true
			
			if TPBTConfig.ShowFrame == "Show in separate frame" then 
				addon:colorFrame(TPBT_onBoss)
				addon:getTarget("boss1") 
			end
			
		elseif event == "PLAYER_REGEN_ENABLED" then
			TPBT_onBoss = false
			addon:colorFrame(TPBT_onBoss)
		end
		
		
		
		
	end)
	
	
	--TPBT_ParentFrame:SetClampedToScreen(true)
	
	--[[
	


	

	-- Create slim header panel to hold title.
	
	TPBT_HeaderPanel:SetFrameStrata("Background")
	TPBT_HeaderPanel:SetWidth(450)
	TPBT_HeaderPanel:SetHeight(22)
	TPBT_HeaderPanel:EnableMouse(true)
	TPBT_HeaderPanel:SetMovable(true)
	TPBT_HeaderPanel:RegisterForDrag("LeftButton")
	TPBT_HeaderPanel:SetScript("OnDragStart", function(self) self:StartMoving() end)
	TPBT_HeaderPanel:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

	TPBT_ParentFrameTexture = TPBT_HeaderPanel:CreateTexture(nil, "Background")
	--TPBT_ParsePanelTexture:SetWidth(128)
	--TPBT_ParsePanelTexture:SetHeight(64)
	TPBT_ParentFrameTexture:ClearAllPoints()
	TPBT_ParentFrameTexture:SetColorTexture(35/255, 35/255, 35/255, 0.55)
	TPBT_ParentFrameTexture:SetAllPoints(TPBT_HeaderPanel)

	TPBT_HeaderPanel:SetPoint("CENTER", UIParent)
	TPBT_HeaderPanel:Show()
	TPBT_HeaderPanel:SetClampedToScreen(true)


	
	
	





	TPBT_ConfigBtn = CreateFrame("Button", "TPBT_ConfigButton", TPBT_HeaderPanel)
	TPBT_ConfigBtn:SetFrameLevel(5)
	TPBT_ConfigBtn:ClearAllPoints()
	TPBT_ConfigBtn:SetHeight(16)
	TPBT_ConfigBtn:SetWidth(16)
	TPBT_ConfigBtn:SetNormalTexture("Interface\\Buttons\\UI-OptionsButton")
	TPBT_ConfigBtn:SetHighlightTexture("Interface\\Buttons\\UI-OptionsButton", 1.0)
	TPBT_ConfigBtn:SetAlpha(0.45)
	TPBT_ConfigBtn:SetPoint("TOPRIGHT", TPBT_HeaderPanel, "TOPRIGHT", -4, -2)

	TPBT_ConfigBtn:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	TPBT_ConfigBtn:SetScript("OnClick", function()
		InterfaceOptionsFrame_OpenToCategory(addon.configPanel)
		InterfaceOptionsFrame_OpenToCategory(addon.configPanel)
		
	end)
	TPBT_ConfigBtn:Show()
	
	-- Minimize Button
	minimizeBtn = CreateFrame("Button", "minimize", TPBT_HeaderPanel)
	minimizeBtn:SetFrameLevel(5)
	minimizeBtn:ClearAllPoints()
	minimizeBtn:SetHeight(30)
	minimizeBtn:SetWidth(30)
	minimizeBtn:SetNormalTexture("Interface\\Buttons\\UI-MultiCheck-Up")
	minimizeBtn:SetHighlightTexture("Interface\\Buttons\\UI-MultiCheck-Up", 1.0)
	minimizeBtn:SetAlpha(0.45)
	minimizeBtn:SetPoint("TOPRIGHT", TPBT_HeaderPanel, "TOPRIGHT", -17, 5)
	minimizeBtn:SetScript("OnClick", function()
		addon:setMinimized()
		
	end)
	
	minimizeBtn:Show()
	
 --]]
end



--[[
lockBtn = CreateFrame("Button", "lock", TPBT_HeaderPanel)
lockBtn:SetFrameLevel(5)
lockBtn:ClearAllPoints()
lockBtn:SetHeight(25)
lockBtn:SetWidth(25)
lockBtn:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Up")
lockBtn:SetHighlightTexture("Interface\\Buttons\\LockButton-Unlocked-Up", 1.0)
lockBtn:SetAlpha(0.35)
lockBtn:SetPoint("TOPRIGHT", TPBT_HeaderPanel, "TOPRIGHT", -17, 0)

lockBtn:RegisterForClicks("LeftButtonUp", "RightButtonUp")
lockBtn:SetScript("OnClick", function()
	InterfaceOptionsFrame_OpenToCategory(configPanel)
	InterfaceOptionsFrame_OpenToCategory(configPanel)
	
end)
lockBtn:Show()
]]--

-- Returns true or false depending on if the user wants the addon on in the current instance.
function addon:checkInstance()
		-- Check if in raid or Mythic+
	local inInstance, instanceType = IsInInstance()
	local _, _, difficultyID = GetInstanceInfo()	
	
	local instanceAllowed = true
	if difficultyID == 8 then 
		if TPBTConfig.MythicPlusToggle then
			instanceAllowed = true
		else
			instanceAllowed = false
		end
	elseif instanceType == "raid" then
		if TPBTConfig.RaidToggle then
			instanceAllowed = true
		else
			instanceAllowed = false
		end	
	end
	return instanceAllowed

end

function addon:setEnabled()
	local inInstance, instanceType = IsInInstance()
	
	--TPBT_MobName:SetText("")
	--TPBT_ParseText:SetText("")
	

	if inInstance and TPBTConfig.ShowFrame == "Show in separate frame" then
		if addon:checkInstance() then
			--TPBT_HeaderPanel:Show()
			TPBT_ParentFrame:Show()
		else
			TPBT_ParentFrame:Hide()
		end
	
		--elseif difficultyID == 
			
		--local mapID = C_Map.GetBestMapForUnit("player")
		--if not acceptedDungeons[mapID] then return end	
		--local isShown = TPBT_ParsePanel:IsVisible()
		--print(isShown)
		
		
		--if not isShown then
		--	TPBT_ParsePanel:Hide()
		--end
	else
		TPBT_ParentFrame:Hide()
	end
end


function addon:setMinimized(forceShow)
	--if not TPBT_ParseText:IsVisible() or forceShow then
	if TPBT_ParsePanel:GetHeight() <= 26 then
		TPBT_ParsePanel:SetHeight(175)
		TPBT_ParseText:Show()
		
	else
		--TPBT_ParsePanel:Hide()
		TPBT_ParsePanel:SetHeight(25)
		TPBT_ParseText:Hide()
	end
end
		
		
function addon:setDropdownEnabled()
	if TPBTConfig.ShowFrame == "Show in separate frame" then
		--targetDD:Show()
		addon.targetFS:Show()
		addon.chkTarget:Show()
		
	else
		--targetDD:Hide()
		addon.targetFS:Hide()
		addon.chkTarget:Hide()
	end

end


function addon:colorFrame(TPBT_onBoss) 
	if TPBT_onBoss then		
		TPBT_ParsePanelTexture:SetColorTexture(100/255, 80/255, 0/255, 0.55)	
		TPBT_ParentFrameTexture:SetColorTexture(70/255, 50/255, 0/255, 0.55)		
	else
		TPBT_ParsePanelTexture:SetColorTexture(55/255, 55/255, 55/255, 0.55)	
		TPBT_ParentFrameTexture:SetColorTexture(35/255, 35/255, 35/255, 0.55)
	end
end



TPBT_onBoss = false

--createTPBTFrame()
